/*
 * 2004-10-29 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile.group.task;

import java.util.Iterator;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.ui.editors.text.TextEditor;
import org.jdom.Element;
import org.vivianj.eclipse.plugin.buildfile.data.Data;
import org.vivianj.eclipse.plugin.buildfile.data.task.Task;
import org.vivianj.eclipse.plugin.buildfile.group.RightGroup;
import org.vivianj.eclipse.plugin.buildfile.util.Resource;
import org.vivianj.eclipse.plugin.buildfile.util.TaskElementUtil;

/**
 * TaskGroupڴͲʾTaskϢPanel
 */
public class TaskGroup extends RightGroup {
	private Group group = null;

	private TextEditor editor = null;

	private Task task = null;

	private Button b_create = null;

	private Button b_update = null;

	private Button b_delete = null;

	/**
	 * TaskGroup
	 * 
	 * @param p_group --
	 *            parent
	 * @param p_task --
	 *            ӦʾTask
	 * @param p_treeItem --
	 *            Ӧڵ
	 */
	public TaskGroup(Group p_group, Task p_task, TreeItem p_treeItem) {
		this.group = p_group;
		this.group.setText(Resource.getSource("task.label"));

		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 3;

		this.group.setLayout(gridLayout);
		this.group.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL
				| GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL
				| GridData.GRAB_VERTICAL));

		this.treeItem = p_treeItem;
		this.task = p_task;
	}

	/**
	 * @param key --
	 *            panelĹؼ
	 */
	public void createPanel(String key) {

		this.createPanelWithTask();
		if (key.equals(RightGroup.UPDATE)) {

			//		°Ŧ
			this.b_update = new Button(this.group, SWT.LEFT);
			b_update.setText(Resource.getSource("pub.update"));
			b_update.addMouseListener(this);

			//		ɾŦ
			this.b_delete = new Button(this.group, SWT.LEFT);
			b_delete.setText(Resource.getSource("pub.delete"));
			b_delete.addMouseListener(this);
		}
		if (key.equals(RightGroup.CREATE)) {
			//µӽڵ㰴Ŧ
			this.b_create = new Button(this.group, SWT.LEFT);
			b_create.setText(Resource.getSource("pub.create"));
			b_create.addMouseListener(this);
		}
	}

	/**
	 * createPanelWithTaskʾLabelTextؼ
	 */
	public void createPanelWithTask() {
		Data data = (Data) this.treeItem.getData();
		String taskName = data.getName();

		List propertyNames = TaskElementUtil.getTaskProperties(taskName);
		Iterator it = propertyNames.iterator();
		Text tmp;
		while (it.hasNext()) {
			String property = ((Element) it.next()).getName();
			String value = this.task.getProperty(property.trim());
			this.createLabel(property, this.group);
			tmp = this.createText(value, this.group);
			tmp.setData(property);
		}

	}

	/**
	 * mouseDownϵİť¼
	 */
	public void mouseDown(MouseEvent me) {
		Button source = (Button) me.getSource();
		if (source == this.b_update || source == this.b_create) {
			Task task = (Task) this.treeItem.getData();
			Control[] control = this.group.getChildren();
			int count = control.length;
			Text tmp;
			String property;
			for (int i = 0; i < count; i++) {
				if (control[i] instanceof Text) {
					tmp = (Text) control[i];
					property = (String) tmp.getData();

					task.setProperty(property, tmp.getText());
				}
			}
			this.treeItem.setText(task.getName());
			this.treeItem.setData(task);
		} else if (source == this.b_delete) {
			this.treeItem.dispose();
		}
		this.group.getParent().layout();
		this.invokeSave();
	}
}