/*
 * 2004-10-23 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile.util;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Iterator;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.ui.editors.text.TextEditor;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.vivianj.eclipse.plugin.buildfile.data.Project;
import org.vivianj.eclipse.plugin.buildfile.data.target.Property;
import org.vivianj.eclipse.plugin.buildfile.data.target.Target;
import org.vivianj.eclipse.plugin.buildfile.data.task.Task;

/**
 * BuildFileTreeITextEditorɶӦbuildfile
 */
public class BuildFileTree {
	private Tree tree = null;

	private Group group = null;

	private TextEditor editor = null;

	private Document document = null;

	/**
	 * BuildFileTree
	 *  
	 */
	public BuildFileTree() {

	}

	public Group getGroup() {
		return group;
	}

	public void setGroup(Group group) {
		this.group = group;
	}

	public TextEditor getTextEditor() {
		return editor;
	}

	public void setTextEditor(TextEditor editor) {
		this.editor = editor;
	}

	public Tree getTree() {
		return tree;
	}

	public void setTree(Tree tree) {
		this.tree = tree;
	}

	//	ݴ򿪵ļProjectDocument
	private void createDocument() {
		try {

			String editorText = editor.getDocumentProvider().getDocument(
					editor.getEditorInput()).get();
			InputStream in = new ByteArrayInputStream(editorText.getBytes());
			SAXBuilder builder = new SAXBuilder();
			document = builder.build(in);
		} catch (IOException ioe) {

		} catch (JDOMException ioe) {

		}
	}

	//Document
	public Tree createTree() {
		// Documentĵ
		this.createDocument();

		Element root = document.getRootElement();
		Project project = new Project(root);
		tree = new Tree(this.group, SWT.SIMPLE);
		tree.setLayout(new GridLayout());
		tree.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL
				| GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL
				| GridData.GRAB_VERTICAL));

		TreeItem rootItem = new TreeItem(tree, SWT.SIMPLE, 0);
		rootItem.setText(project.getName());
		rootItem.setData(project);
		tree.setTopItem(rootItem);

		//PropertyӦڵ
		this.createProperty(rootItem);
		//TargetӦڵ
		this.createTarget(rootItem);

		return tree;
	}

	//	TargetԪضӦڵ
	private void createTarget(TreeItem treeItem) {
		Element root = document.getRootElement();
		List list = root.getChildren("target");
		Iterator it = list.iterator();

		Element element = null;
		Target target = null;
		while (it.hasNext()) {

			element = (Element) it.next();
			target = new Target(element);
			TreeItem targetItem = new TreeItem(treeItem, SWT.SIMPLE);
			targetItem.setText(target.getName());
			targetItem.setData(target);
			//Targetڵ
			List child = element.getChildren();

			Iterator childIterator = child.iterator();
			while (childIterator.hasNext()) {
				Element taskElement = (Element) childIterator.next();
				this.createTask(taskElement, targetItem);
			}
		}
	}

	//PropertyԪضӦڵ
	private void createProperty(TreeItem treeItem) {
		Element root = document.getRootElement();
		List list = root.getChildren("property");
		Iterator it = list.iterator();

		Element element = null;
		Property property = null;
		while (it.hasNext()) {

			element = (Element) it.next();
			property = new Property(element);
			TreeItem targetItem = new TreeItem(treeItem, SWT.SIMPLE);
			targetItem.setText(property.getName());
			targetItem.setData(property);
		}
	}

	//	TaskԪضӦڵ
	private void createTask(Element element, TreeItem treeItem) {
		Task task = null;
		task = new Task(element);
		TreeItem taskItem = new TreeItem(treeItem, SWT.SIMPLE);
		taskItem.setText(task.getName());
		taskItem.setData(task);
	}
}