/*
 * 2004-10-24 Фݼ 
 */
package org.vivianj.eclipse.plugin.buildfile.util;

import java.util.Iterator;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.ui.editors.text.TextEditor;
import org.jdom.Element;
import org.vivianj.eclipse.plugin.buildfile.data.Data;
import org.vivianj.eclipse.plugin.buildfile.data.Project;
import org.vivianj.eclipse.plugin.buildfile.data.target.Target;
import org.vivianj.eclipse.plugin.buildfile.group.RightGroup;

/**
 * ڵĹ
 */
public class ShellFactory {
	private Data data = null;

	private Shell parent = null;

	private Group group = null;

	private TreeItem treeItem = null;

	private TextEditor editor = null;

	/**
	 * 
	 * ShellFactory
	 */
	public ShellFactory() {
	}

	public TextEditor getEditor() {
		return editor;
	}

	public void setEditor(TextEditor editor) {
		this.editor = editor;
	}

	public Data getData() {
		return data;
	}

	public void setData(Data data) {
		this.data = data;
	}

	public Group getGroup() {
		return group;
	}

	public void setGroup(Group group) {
		this.group = group;
	}

	public Shell getParent() {
		return parent;
	}

	public void setParent(Shell parent) {
		this.parent = parent;
	}

	public TreeItem getTreeItem() {
		return treeItem;
	}

	public void setTreeItem(TreeItem treeItem) {
		this.treeItem = treeItem;
	}

	/**
	 * 
	 * @param data
	 *            ڵӦData
	 * @param parent
	 *            paren
	 * @param group
	 *            ڵʾʵ
	 * @param treeItem
	 *            Ӧڵ
	 * @param editor
	 *            ITextEditorʵ
	 */
	public static void createShell(Data data, Shell parent, Group group,
			TreeItem treeItem, TextEditor editor) {
		ShellFactory menuFactory = new ShellFactory();
		menuFactory.setData(data);
		menuFactory.setGroup(group);
		menuFactory.setParent(parent);
		menuFactory.setTreeItem(treeItem);
		menuFactory.setEditor(editor);

		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		parent.setLayout(gridLayout);

		if (data instanceof Project) {
			menuFactory.createProjectMenu();
		} else if (data instanceof Target) {
			menuFactory.createTaskMenu();
		}
	}
	
	private void createProjectMenu() {
		this.createButton(Resource.getSource("shell.new.properties"), parent,
				DataFactory.PROPERTIES);
		this.createButton(Resource.getSource("shell.new.target"), parent,
				DataFactory.TARGET);
	}

	private void createTaskMenu() {
		Element element = TaskElementUtil.getRoot();
		List list = element.getChildren();
		Iterator it = list.iterator();
		while (it.hasNext()) {
			String taskName = ((Element) it.next()).getName();
			this.createButton(Resource.getSource("task.new.prefix") + taskName,
					parent, taskName);
		}
	}

	private void createButton(String text, Shell parent, String key) {
		Button button = new Button(parent, SWT.RADIO);
		button.setLayoutData(new GridLayout());
		button.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL
				| GridData.VERTICAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		button.setText(text);
		button.addMouseListener(new ButtonMouseListener(this.data, this.group,
				this.treeItem, this.parent, key, this.editor));
	}

	class ButtonMouseListener extends MouseAdapter {
		private Group group = null;

		private TreeItem treeItem = null;

		private Data data = null;

		private Shell shell = null;

		private TextEditor editor = null;

		private String key = null;

		public ButtonMouseListener(Data data, Group group, TreeItem treeItem,
				Shell shell, String key, TextEditor p_editor) {
			this.group = group;
			this.treeItem = treeItem;
			this.data = data;
			this.shell = shell;
			this.key = key;
			this.editor = p_editor;
		}

		public Data getData() {
			return data;
		}

		public void setData(Data data) {
			this.data = data;
		}

		public Group getGroup() {
			return group;
		}

		public void setGroup(Group group) {
			this.group = group;
		}

		public TreeItem getTreeItem() {
			return treeItem;
		}

		public void setTreeItem(TreeItem treeItem) {
			this.treeItem = treeItem;
		}

		public void mouseDown(MouseEvent event) {
			//µĽڵ
			TreeItem t_treeItem = new TreeItem(this.treeItem, SWT.SIMPLE);
			Data data = DataFactory.getDefault(this.key);
			t_treeItem.setData(data);
			t_treeItem.setText(data.getName());
			t_treeItem.getParent().setSelection(new TreeItem[] { t_treeItem });

			//			еĿؼ
			ControlDispose.disposeControls(this.group);

			//µ
			this.createGroup(data, t_treeItem, RightGroup.CREATE);

			shell.dispose();
		}

		private void createGroup(Object o, TreeItem p_treeItem, String key) {
			//			µ
			RightGroup rightGroup = GroupFactory.getGroup(o, this.group,
					p_treeItem);
			rightGroup.createPanel(key);
			rightGroup.setEditor(this.editor);
			//	      ˢ½
			this.redraw();
		}

		private void redraw() {
			this.group.layout();
			this.group.getParent().layout();
		}
	}
}